std::is_enum(3)

NAME
std::is_enum - std::is_enum

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_enum;
   std::is_enum is a UnaryTypeTrait.
   Checks whether T is an enumeration type. Provides the member constant value which is
   equal to true, if T is an enumeration type. Otherwise, value is equal to false.
   If the program adds specializations for std::is_enum or std::is_enum_v, the behavior
   is undefined.

Template parameters
   T - a type to check
   Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_enum_v = is_enum<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is an enumeration type, false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Example
// Run this code
 #include <type_traits>
 struct A { enum E {}; };
 static_assert(std::is_enum_v<A> == false);
 static_assert(std::is_enum_v<A::E> == true);
 enum E {};
 static_assert(std::is_enum_v<E> == true);
 enum class Ec : int {};
 static_assert(std::is_enum_v<Ec> == true);
 static_assert(std::is_enum_v<int> == false);
 int main() {}

See also
   is_integral checks if a type is an integral type
   (C++11) (class template)
   is_arithmetic checks if a type is an arithmetic type
   (C++11) (class template)
   is_scalar checks if a type is a scalar type
   (C++11) (class template)
   is_scoped_enum checks if a type is a scoped enumeration type
   (C++23) (class template)